// EEPROM read and writes

// use for storing and recalling presets and updating active parameters


void recal_EEPROM ()
{
  int Update; // loop to update EEPROM
  int UpdateB = 1;

  // Euclidian EEPROM READ
  UpdateB = 1;
  for (Update = 0; Update < 3; Update++)
  {
    channelbeats[Update][0]  =  EEPROM.read(UpdateB + Preset_offset);      // read n
    channelbeats[Update][1]  =  EEPROM.read(UpdateB + 1 + Preset_offset);  // read k
    channelbeats[Update][2]  = 0; // set position to zero
    UpdateB = UpdateB + 2;
  }

  for (Update = 0; Update < 3; Update++)
  {
    channelbeats[Update][3]  =  EEPROM.read(Update + 7 + Preset_offset);   // read o
    channelbeats[Update][4]  =  EEPROM.read(Update + 10 + Preset_offset);  // read whatever's in column 5
  }

  // MIDI EEPROM READ
  MIDI_chan = EEPROM.read(13 + Preset_offset); // MIDI channel (1-16)
  for (Update = 0; Update < 4; Update++)
  {
    //  EEPROM.write((Update + 13), MIDI_chan);                // write midi channel
    MIDI_sets[Update][0]  =  EEPROM.read(Update + 17 + Preset_offset);   // read velocity setting 4 seq channel
    MIDI_sets[Update][1]  =  EEPROM.read(Update + 21 + Preset_offset);   // read note setting 4 seq channel
  }

  // Write to working space EEPROM

  for (Update = 0; Update < 3; Update++)
  {

    if (EEPROM.read(UpdateB) != channelbeats[Update][0]) {
      EEPROM.write((UpdateB), channelbeats[Update][0]); // write n
    }
    if (EEPROM.read(UpdateB + 1) != channelbeats[Update][1]) {
      EEPROM.write((UpdateB + 1), channelbeats[Update][1]); // write k
    }
    UpdateB = UpdateB + 2;
  }

  for (Update = 0; Update < 3; Update++)
  {
    if (EEPROM.read(Update + 7) != channelbeats[Update][3]) {
      EEPROM.write((Update + 7), channelbeats[Update][3]); // write o
    }
    if (EEPROM.read(Update + 10) != channelbeats[Update][4]) {
      EEPROM.write((Update + 10), channelbeats[Update][4]); // write whatever's in column 5
    }
  }

  for (Update = 0; Update < 4; Update++)
  {

    EEPROM.write((Update + 13), MIDI_chan); // write midi channel
    EEPROM.write((Update + 17), MIDI_sets[Update][0]); // write velocity setting for active seq channel
    EEPROM.write((Update + 21), MIDI_sets[Update][1]); // write note setting for active seq channel
  }


// load new data into euclidian routine

 for (int a = 0; a < channels; a++) {
    beat_holder[a] = euclid(channelbeats[a][0], channelbeats[a][1], channelbeats[a][3]);
  }
  
 /* for (a = 0; a < channels; a++)
  {
    nn = channelbeats[a][0];
    kk = channelbeats[a][1];
    oo = channelbeats[a][3];
    beat_holder[a] = euclid(nn, kk, oo);
  }*/
  
  nn = channelbeats[active_channel][0];
  kk = channelbeats[active_channel][1];
  oo = channelbeats[active_channel][3];
  beat_holder[active_channel] = euclid(nn, kk, oo);

}

//------------------------------------------------------------------------------------

void store_EEPROM()
{
  int Update; // loop to update EEPROM
  int UpdateB = 1;

  // Euclidian EEPROM Write
  UpdateB = 1;
  for (Update = 0; Update < 3; Update++)
  {
    EEPROM.write((UpdateB + Preset_offset), channelbeats[Update][0]);      // write n
    EEPROM.write((UpdateB + 1 + Preset_offset), channelbeats[Update][1]);  // write k
    UpdateB = UpdateB + 2;
  }

  for (Update = 0; Update < 3; Update++)
  {
    EEPROM.write((Update + 7 + Preset_offset), channelbeats[Update][3]);   // write o
    EEPROM.write((Update + 10 + Preset_offset), channelbeats[Update][4]);  // write whatever's in column 5
  }

  // MIDI EEPROM Write
  for (Update = 0; Update < 4; Update++)
  {
    EEPROM.write((Update + 13 + Preset_offset), MIDI_chan);                // write midi channel
    EEPROM.write((Update + 17 + Preset_offset), MIDI_sets[Update][0]);     // write velocity setting for active seq channel
    EEPROM.write((Update + 21 + Preset_offset), MIDI_sets[Update][1]);     // write note setting for active seq channel

  }

}

//END

