
// Read the switches routing for MIDI mode


//	Knobs on Syinsi PCB (from top to bottom) are Length, Density, Offset.

void M_read_switches()
{

  // display which Euclidian sequencer channel is being updated
  // first 4 LEDs of row 7 show sequencer channel

  if (M_displayDelay == 1) {
    lc.setRow(0, 6, false); //clear row 7
    //lc.setLed(0, 6, 5 - (active_channel * 2), true);
    //lc.setLed(0, 6, 5 - (active_channel * 2) - 1, true);
    switch (activeMIDI + 1) {
      case 1:
        lc.setRow(0, 6, B00000001);
        break;
      case 2:
        lc.setRow(0, 6, B00000010);
        break;
      case 3:
        lc.setRow(0, 6, B00000100);
        break;
      case 4:
        lc.setRow(0, 6, B00001000);
        break;
    }
  }
  // -------------- test for long press in MIDI mode ---------------------

  // switch pressed - start timing it

  if (channel_switch != 3 && old_channel_switch == 3) {
    long_press = time;
  }

  // switch held - how long

  if (channel_switch != 3 && old_channel_switch != 3) {
    if (time - long_press > 2000) {

      switch (channel_switch + 1) {
        case 1:                      // long press return to Euclidian mode
          MIDI_Mode = 1;
          lc.setRow(0, 7, B0000000);
          M_displayDelay = 1;
          break;
        case 2:
          // unused in long press
          break;
        case 3:                      // long press enters Preset Read/Write mode
          Previous_Mode = MIDI_Mode; //store the mode leaving
          MIDI_Mode = 3;
          lc.setRow(0, 7, B11011011);
          M_displayDelay = 2;        // lock bottom row update off
          Preset_number = 1;
          Preset_offset = (Preset_number * Preset_size) + 1;
          dots_octave = B11011011;                       //set row 8 to preset function warning
          dots = Preset_number;
          barGraph();                                    //Display preset number on row 7 solid line on 8
          break;
      }

      long_press = time;
      lc.setRow(0, 6, false); //clear row 7
    }
  }

  old_channel_switch = channel_switch;                    // store state this loop to compare next time
}


//------------------------Subroutines--------------------

// Encoder 1 press advances active midi note to the next one
void M_advance_MIDI()
{
  channel_switch = 0;
  if (channel_switch != 3 && old_channel_switch == 3)   // check for new switch press and debounce
  {
    activeMIDI ++;           // increment only once per press
  }

  activeMIDI = activeMIDI & 3; // limit to 4 possible states
  last_read = millis();
}

//END
